# agrajag

> Short blurb about what your product does.

[![PyPI][pypi-image]][pypi-url]
[![Downloads][downloads-image]][downloads-url]
[![Status][status-image]][pypi-url]
[![Python Version][python-version-image]][pypi-url]
[![tests][tests-image]][tests-url]
[![Codecov][codecov-image]][codecov-url]
[![CodeQl][codeql-image]][codeql-url]
[![Docker][docker-image]][docker-url]
[![pre-commit][pre-commit-image]][pre-commit-url]
[![pre-commit.ci status][pre-commit.ci-image]][pre-commit.ci-url]
[![readthedocs][readthedocs-image]][readthedocs-url]
[![CodeFactor][codefactor-image]][codefactor-url]
[![Codeclimate][codeclimate-image]][codeclimate-url]
[![Imports: isort][isort-image]][isort-url]
[![Code style: black][black-image]][black-url]
[![Checked with mypy][mypy-image]][mypy-url]
[![security: bandit][bandit-image]][bandit-url]
[![Commitizen friendly][commitizen-image]][commitizen-url]
[![Conventional Commits][conventional-commits-image]][conventional-commits-url]
[![Versioning][versioning-image]][versioning-url]
[![DeepSource][deepsource-image]][deepsource-url]
[![license][license-image]][license-url]
[![Pydough][pydough-image]][pydough-url]

One to two paragraph statement about your product and what it does.

![](assets/header_dough1.png)

# Contents

-   [Demo](#-demo)
-   [Project rationale](#-project-rationale)
-   [Quick start](#-quickstart)
    -   [Prerequisites](#-prerequisites)
    -   [Installation](#-installation)
    -   [Basic Usage](#-basic-usage)
-   [Usage](#-usage)
-   [Development setup](#-development-setup)
-   [Configuration](#-configuration)
-   [Documentation](#-documentation)
    -   [Read the Docs](https://pynamer.readthedocs.io/en/latest/)
    -   [API](https://pynamer.readthedocs.io/en/latest/autoapi/pynamer/pynamer/index.html)
    -   [Wiki](https://github.com/Stephen-RA-King/pynamer/wiki)
-   [FAQs](#-faqs)
-   [What's new in version x.x](#-whats-new-in-version-xx)
-   [Planned future enhancements](#-planned-future-enhancements)
-   [Package statistics](#-package-statistics)
-   [License](#-license)
-   [Meta information](#ℹ-meta)

# 📺 Demo

---

Put a demo animated gif here.

# 💡 Project rationale

---

Why I built this project

## 👓 TLDR

A very succinct paragraph summary regarding the package purpose and operation.

# 🚀 Quickstart

---

Explain succinctly how to use the repository

## 📋 Prerequisites

-   A bulleted list of requirements

## 💾 Installation

OS X & Linux:

```sh
pip3 install agrajag
```

Windows:

```sh
pip install agrajag
```

## 📝 Basic Usage

A simple example demonstrating that the package is working

# 📝 Usage

---

A few motivating and useful examples of how your product can be used. Spice this up with code blocks and potentially more screenshots.

_For more examples and usage, please refer to the [Wiki][wiki]._

# 🔧 Development setup

---

Describe how to install all development dependencies and how to run an automated test-suite of some kind. Potentially do this for multiple platforms.

```sh
pip install --editable agrajag
```

# ⚙️ Configuration

---

Place configuration information here

# 🔒 Security Considerations

---

Write any security concerns that you may have here.
e.g. exposure of API keys, passwords, old modules etc.

# 📚 Documentation

---

[**Read the Docs**](https://agrajag.readthedocs.io/en/latest/)

-   [**Example Usage**](https://agrajag.readthedocs.io/en/latest/example.html)
-   [**Credits**](https://agrajag.readthedocs.io/en/latest/example.html)
-   [**Changelog**](https://agrajag.readthedocs.io/en/latest/changelog.html)
-   [**API Reference**](https://agrajag.readthedocs.io/en/latest/autoapi/index.html)

[**Wiki**](https://github.com/Stephen-RA-King/agrajag/wiki)

# 🧬 Design Considerations

---

A few paragraphs on the design considerations if required.

# 🐳 Using Docker

---

## Building the Image from Dockerfile

Start your docker runtime then:

Build the image using **_docker build_** command. e.g.

```shell
$ docker build -t sraking/agrajag:0.1.0 -t sraking/agrajag:latest .
```

Once built, run the image using the **_docker run_** command. This will create the container. e.g.

```shell
$ docker run -it sraking/agrajag:0.1.0 /bin/bash
```

Optional: The image can now be pushed to the repository using the **_docker push_** command. e.g.

```shell
$ docker push sraking/agrajag:0.1.0
```

## Using the ready built image on dockerhub

Pull the latest image from the repository using the **_docker pull_** command. e.g.

```bash
~ $ docker pull sraking/agrajag
```

Now run the image using the **_docker run_** command. This will create the container. e.g.

```bash
~ $ docker run -it sraking/agrajag /bin/bash
```

Use the command line as normal in the container.

```bash
root@4d315992ca28:/app# agrajag -h
```

# ⚠️ Limitations

---

Describe any limitation the application may have (if any).

# ⁉️ Some Quirks

---

The reason I wrote this application in the first place.

## ❓ FAQs

---

Give examples of frequently asked questions

# 📰 What's new in version x.x

---

-   bulleted list of new features

# 📆 Planned future enhancements

---

-   Feature 1
-   Feature 2

# 📊 Package statistics

---

-   [**libraries.io**](https://libraries.io/pypi/Stephen-RA-King)
-   [**PyPI Stats**](https://pypistats.org/packages/Stephen-RA-King)
-   [**Pepy**](https://www.pepy.tech/projects/Stephen-RA-King)

# 📜 License

---

Distributed under the MIT license. See [![][license-image]][license-url] for more information.

# <ℹ️> Meta

---

[![](assets/linkedin.png)](https://www.linkedin.com/in/sr-king)
[![](assets/github.png)](https://github.com/Stephen-RA-King)
[![](assets/pypi.png)](https://pypi.org/project/agrajag)
[![Docker](assets/docker.png)](https://hub.docker.com/r/sraking/agrajag)
[![](assets/www.png)](https://stephen-ra-king.github.io/justpython/)
[![](assets/email2.png)](mailto:sking.github@gmail.com)
[![](assets/github.png)](https://github.com/Stephen-RA-King/agrajag)

Author: Stephen R A King ([sking.github@gmail.com](mailto:sking.github@gmail.com))

Created with Cookiecutter template: [![pydough][pydough-image]][pydough-url] version 1.3.4

Digital object identifier: [![DOI](https://zenodo.org/badge/xxxxxxxxx.svg)](https://zenodo.org/badge/latestdoi/xxxxxxxxx)

<!-- Markdown link & img dfn's -->

[bandit-image]: https://img.shields.io/badge/security-bandit-yellow.svg
[bandit-url]: https://github.com/PyCQA/bandit
[black-image]: https://img.shields.io/badge/code%20style-black-000000.svg
[black-url]: https://github.com/psf/black
[codeclimate-image]: https://api.codeclimate.com/v1/badges/7fc352185512a1dab75d/maintainability
[codeclimate-url]: https://codeclimate.com/github/Stephen-RA-King/agrajag/maintainability
[codecov-image]: https://codecov.io/gh/Stephen-RA-King/agrajag/branch/main/graph/badge.svg
[codecov-url]: https://app.codecov.io/gh/Stephen-RA-King/agrajag
[codefactor-image]: https://www.codefactor.io/repository/github/Stephen-RA-King/agrajag/badge
[codefactor-url]: https://www.codefactor.io/repository/github/Stephen-RA-King/agrajag
[codeql-image]: https://github.com/Stephen-RA-King/agrajag/actions/workflows/github-code-scanning/codeql/badge.svg
[codeql-url]: https://github.com/Stephen-RA-King/agrajag/actions/workflows/github-code-scanning/codeql
[commitizen-image]: https://img.shields.io/badge/commitizen-friendly-brightgreen.svg
[commitizen-url]: http://commitizen.github.io/cz-cli/
[conventional-commits-image]: https://img.shields.io/badge/Conventional%20Commits-1.0.0-yellow.svg?style=flat-square
[conventional-commits-url]: https://conventionalcommits.org
[deepsource-image]: https://app.deepsource.com/gh/Stephen-RA-King/agrajag.svg/?label=active+issues&show_trend=true
[deepsource-url]: https://app.deepsource.com/gh/Stephen-RA-King/agrajag/?ref=repository-badge
[docker-image]: https://github.com/Stephen-RA-King/agrajag/actions/workflows/docker-image.yml/badge.svg
[docker-url]: https://github.com/Stephen-RA-King/agrajag/actions/workflows/docker-image.yml
[downloads-image]: https://static.pepy.tech/personalized-badge/agrajag?period=total&units=international_system&left_color=black&right_color=orange&left_text=Downloads
[downloads-url]: https://pepy.tech/project/agrajag
[format-image]: https://img.shields.io/pypi/format/agrajag
[isort-image]: https://img.shields.io/badge/%20imports-isort-%231674b1?style=flat&labelColor=ef8336
[isort-url]: https://github.com/pycqa/isort/
[lgtm-alerts-image]: https://img.shields.io/lgtm/alerts/g/Stephen-RA-King/agrajag.svg?logo=lgtm&logoWidth=18
[lgtm-alerts-url]: https://lgtm.com/projects/g/Stephen-RA-King/agrajag/alerts/
[lgtm-quality-image]: https://img.shields.io/lgtm/grade/python/g/Stephen-RA-King/agrajag.svg?logo=lgtm&logoWidth=18
[lgtm-quality-url]: https://lgtm.com/projects/g/Stephen-RA-King/agrajag/context:python
[license-image]: https://img.shields.io/pypi/l/agrajag
[license-url]: https://github.com/Stephen-RA-King/agrajag/blob/main/LICENSE
[mypy-image]: http://www.mypy-lang.org/static/mypy_badge.svg
[mypy-url]: http://mypy-lang.org/
[pre-commit-image]: https://img.shields.io/badge/pre--commit-enabled-brightgreen?logo=pre-commit&logoColor=white
[pre-commit-url]: https://github.com/pre-commit/pre-commit
[pre-commit.ci-image]: https://results.pre-commit.ci/badge/github/Stephen-RA-King/agrajag/main.svg
[pre-commit.ci-url]: https://results.pre-commit.ci/latest/github/Stephen-RA-King/agrajag/main
[pydough-image]: https://img.shields.io/badge/pydough-2023-orange?logo=cookiecutter
[pydough-url]: https://github.com/Stephen-RA-King/pydough
[pypi-url]: https://pypi.org/project/agrajag/
[pypi-image]: https://img.shields.io/pypi/v/agrajag.svg
[python-version-image]: https://img.shields.io/pypi/pyversions/agrajag
[readthedocs-image]: https://readthedocs.org/projects/agrajag/badge/?version=latest
[readthedocs-url]: https://agrajag.readthedocs.io/en/latest/?badge=latest
[status-image]: https://img.shields.io/pypi/status/agrajag.svg
[tests-image]: https://github.com/Stephen-RA-King/agrajag/actions/workflows/tests.yml/badge.svg
[tests-url]: https://github.com/Stephen-RA-King/agrajag/actions/workflows/tests.yml
[versioning-image]: https://img.shields.io/badge/versioning-semver_2-blue
[versioning-url]: https://semver.org/
[wiki]: https://github.com/Stephen-RA-King/agrajag/wiki
